	//	Copyright: 	� Copyright 2004 Apple Computer, Inc. All rights reserved.

	//	printf("Info: ComplexPlayThru will use %ld channels\n",asbd.mChannelsPerFrame);
	//	printf("AudioDevice::Init(AudioDeviceID devid, bool isInput)\n");

	#include "AudioDevice.h"

	#pragma mark -
	#pragma mark === Audio Device Methodes ===
//  AUDIO DEVICE METHODES **********************************************************************************

	void AudioDevice::Init(AudioDeviceID devid, bool isInput)
	{
		printf("AudioDevice::Init(AudioDeviceID devid, bool isInput)\n");
		UInt32 propsize;
		
		mID = devid;
		mIsInput = isInput;
		if (mID == kAudioDeviceUnknown) return;
/*		
	AudioDeviceGetProperty( AudioDeviceID           inDevice,
						   UInt32                  inChannel,
						   Boolean                 isInput,
						   AudioDevicePropertyID   inPropertyID,
						   UInt32*                 ioPropertyDataSize,
						   void*                   outPropertyData)   
	
	AudioObjectGetPropertyData( AudioObjectID                      inObjectID,
							   const AudioObjectPropertyAddress*   inAddress,
							   UInt32                              inQualifierDataSize,
							   const void*                         inQualifierData,
							   UInt32*                             ioDataSize,
							   void*                               outData)
*/	
		propsize = sizeof(UInt32);
		verify_noerr(AudioDeviceGetProperty(mID, 0, mIsInput, kAudioDevicePropertySafetyOffset, &propsize, &mSafetyOffset));
	
		propsize = sizeof(UInt32);
		verify_noerr(AudioDeviceGetProperty(mID, 0, mIsInput, kAudioDevicePropertyBufferFrameSize, &propsize, &mBufferSizeFrames));
	
		propsize = sizeof(AudioStreamBasicDescription);
		verify_noerr(AudioDeviceGetProperty(mID, 0, mIsInput, kAudioDevicePropertyStreamFormat, &propsize, &mFormat));	
	}


	void AudioDevice::SetBufferSize(UInt32 size)
	{
		printf("AudioDevice::SetBufferSize(UInt32 size)\n");
		UInt32 propsize = sizeof(UInt32);
		verify_noerr(AudioDeviceSetProperty(mID, NULL, 0, mIsInput, kAudioDevicePropertyBufferFrameSize, propsize, &size));

		propsize = sizeof(UInt32);
		verify_noerr(AudioDeviceGetProperty(mID, 0, mIsInput, kAudioDevicePropertyBufferFrameSize, &propsize, &mBufferSizeFrames));
	}


	int AudioDevice::CountChannels()
	{
		printf("AudioDevice::CountChannels()\n");
		OSStatus err;
		UInt32 propSize;
		int result = 0;
	
		err = AudioDeviceGetPropertyInfo(mID, 0, mIsInput, kAudioDevicePropertyStreamConfiguration, &propSize, NULL);
		if (err) return 0;

		AudioBufferList *buflist = (AudioBufferList *)malloc(propSize);
		err = AudioDeviceGetProperty(mID, 0, mIsInput, kAudioDevicePropertyStreamConfiguration, &propSize, buflist);
		if (!err)
		{
			for (UInt32 i = 0; i < buflist->mNumberBuffers; ++i)
			{	result += buflist->mBuffers[i].mNumberChannels; }
		}
		free(buflist);
		return result;
	}


	char *	AudioDevice::GetName(char *buf, UInt32 maxlen)
	{
		printf("AudioDevice::GetName(char *buf, UInt32 maxlen)\n");
		verify_noerr(AudioDeviceGetProperty(mID, 0, mIsInput, kAudioDevicePropertyDeviceName, &maxlen, buf));
		return buf;
	}
