//
//  Play_Through_Controller.h
//  Play Through Lion
//
//  Created by John Geelen on 22-09-11.
//  Copyright 2011 JG Electronics. All rights reserved.
//	Remarks, reports to: www.jgelectronics.nl.
//
//	Derived from Apple's example program Complex Play Through and Chen Kok's CocoaFilter.
//	The application icon is from Vincent Garnier http://benjigarner.deviantart.com/art/Fruity-Apples-80805804
//
//	Cocoa, OSX10.6 <> 10.7 and XCODE 4.1.0
//
/*
 Disclaimer: IMPORTANT: 
 This JG Electronics software is supplied to you by JG Electronics as FREE AND OPEN SOURCE SOFTWARE. 
 
 The JG Electronics Software is provided by JG Electronics on an "AS IS" basis.
 JG ELECTRONICS MAKES NO WARRANTIES, EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION
 THE IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS
 FOR A PARTICULAR PURPOSE, REGARDING THE JG ELECTRONICS SOFTWARE OR ITS USE AND
 OPERATION ALONE OR IN COMBINATION WITH YOUR PRODUCTS.
 
 IN NO EVENT SHALL JG ELECTRONICS BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL
 OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) ARISING IN ANY WAY OUT OF THE USE, REPRODUCTION,
 MODIFICATION AND/OR DISTRIBUTION OF THE JG ELECTRONICS SOFTWARE, HOWEVER CAUSED
 AND WHETHER UNDER THEORY OF CONTRACT, TORT (INCLUDING NEGLIGENCE),
 STRICT LIABILITY OR OTHERWISE, EVEN IF JG ELECTRONICS HAS BEEN ADVISED OF THE
 POSSIBILITY OF SUCH DAMAGE.
 */

#import <Foundation/Foundation.h>
#include  "ComplexPlayThru.h"
#include  "AudioDeviceList.h"

@interface Play_Through_Controller : NSObject {
	IBOutlet NSBox *				box;
//  buttons
	IBOutlet NSPopUpButton *		mInputDevices;
	IBOutlet NSPopUpButton *		mOutputDevices;
	IBOutlet NSButton *				mStartButton;
	IBOutlet NSProgressIndicator *	mProgress;
//	variables
	ComplexPlayThru *				playThru;
	AudioDeviceList *				mInputDeviceList;
	AudioDeviceList *				mOutputDeviceList;
	AudioDeviceID					inputDevice;
	AudioDeviceID					outputDevice;
}

//	action methods
- (IBAction)inputDeviceSelected:(id)sender;
- (IBAction)outputDeviceSelected:(id)sender;
- (IBAction)StartStop:(id)sender;
- (IBAction)Reset:(id)sender;
//	audio methods
- (void)initPlaythru;

@end
